<form method="POST">

    <div class="lateral-menu">
        <!-- Menu Button - Layer 1: Open the lateral menu -->
        <div class="rm-element lm-e0 lm-layer1 btn-unstyled rm-btn">
            <div class="rm-btn-icon">
                <img src="{{ url_for('static', filename='img/chevron-left-solid-dark.svg') }}" />
            </div>
        </div>

        <!-- Chevron-right - TO REMOVE? -->
        <!-- <div class="rm-element lm-e0 lm-layer2 btn-unstyled rm-btn">
            <div class="rm-btn-icon">
                <img src="{{ url_for('static', filename='img/chevron-right-solid.svg') }}" />
            </div>
        </div> -->

        <!-- Menu Header - Layer 2: Header -->
        <div class="lm-element lm-section lm-header lm-layer2">
            <button type="submit" name="explorer_mods_reload" class="btn-unstyled menu-btn" title="Load/reload modlist">
                <img src="{{ url_for('static', filename='img/arrows-rotate-solid.svg') }}" />
            </button>
            <h3 class="lm-title text-nobreak">Records Explorer</h3>
            <button type="submit" name="lateral_menu_help" class="btn-unstyled menu-btn wip" title="Tutorial is currently WIP for this widget">
                <img src="{{ url_for('static', filename='img/circle-question-solid.svg') }}" />
            </button>
        </div>


        <!-- Menu Plugins/Record Displayer Header - Layer 2: Section 2 -->
        <div class="lm-element lm-section lm-s1-header lm-layer2">

            <!-- Plugins: Tabs (sort mods by extension, ie ESP, ESM or ESL) - Layer 2 -->
            <input type="checkbox" name="mods_esp_select" id="esp_tab_input" class="tab-checkbox" value="" onfocus="this.select()">
            <label for="esp_tab_input" id="displayEspTab" class="tab-label lm-section-header lm-section-header-tab">ESP</label>

            <input type="checkbox" name="mods_esm_select" id="esm_tab_input" class="tab-checkbox" value="" onfocus="this.select()">
            <label for="esm_tab_input" id="displayEsmTab" class="tab-label lm-section-header lm-section-header-tab">ESM</label>

            <input type="checkbox" name="mods_esl_select" id="esl_tab_input" class="tab-checkbox" value="" onfocus="this.select()">
            <label for="esl_tab_input" id="displayEslTab" class="tab-label lm-section-header lm-section-header-tab">ESL</label>

            <!-- Record Details: Header (title with button to close Details) - Layer 3 -->
            <div id="selectedRecordHeader" class="lm-section-header lm-section-header-title lm-layer3">
                <span class="lm-section-header-text">
                    <div class="lm-section-header-icon menu-cat-icon">
                        <img src="{{ url_for('static', filename='img/eye-solid.svg') }}" />
                    </div>
                    <span>Record Details</span>
                </span>
                <span>
                    <button type="button" class="btn-unstyled lm-section-header-btn" title="Close" onclick="closeRecordDetails()">
                        <img src="{{ url_for('static', filename='img/xmark-solid.svg') }}" />
                    </button>
                </span>
            </div>
        </div>


        <!-- Menu Plugins/Record Displayer - Layer 2: Section 2 -->
        <div class="lm-element lm-section lm-s1 lm-layer2 bg-dark">
        <!-- OLD: position: relative; -->

            <!-- Plugins: ESP List - Layer 2 -->
            <table id="esp_tab_content" class="lm-section-table tab-content">
                <!-- <thead><tr><th>Import distributed records from...</th></tr></thead> -->
                {% if explorer.mods %}
                    {% for i in explorer.mods.get('esp', []) %}
                        <tr class="{% if loop.index0 % 2 != 0 %} bg-light{% endif %}" title="{{ i }}">
                            <td> <!-- name loop.index0 -->
                                <input type="checkbox" class="checkbox" name="{{ i }}" id="" value="{{ true }}" onfocus="this.select()">
                                <!-- style="appearance: none; width: 10px; height: 10px; border: solid 2px green; border-radius: 50%;" -->
                            </td>
                            <td class="lm-table-text lm-table-sub75 text-truncate">{{ i.name }}</td>
                            <!-- DEBUG CELLS -->
                            <!-- <td>loop.index0</td> -->
                            <!-- <td>i.get('selected')</td> -->
                        </tr>
                    {% endfor %}
                {% endif %}
            </table>

            <!-- Add a separator here (border-bottom) ? +/- title (next tab-name) ? -->

            <!-- Plugins: ESM List - Layer 2 -->
            <table id="esm_tab_content" class="lm-section-table tab-content">
                {% if explorer.mods %}
                    {% for i in explorer.mods.get('esm', []) %}
                        <tr class="{% if loop.index0 % 2 != 0 %} bg-light{% endif %}" title="{{ i }}">
                            <td>
                                <input type="checkbox" class="checkbox" name="{{ i }}" id="" value="{{ true }}" onfocus="this.select()">
                            </td>
                            <td class="lm-table-text lm-table-sub75 text-truncate">{{ i.name }}</td>
                        </tr>
                    {% endfor %}
                {% endif %}
            </table>

            <!-- Add a separator here (border-bottom) ? +/- title (next tab-name) ? -->

            <!-- Plugins: ESL List - Layer 2 -->
            <table id="esl_tab_content" class="lm-section-table tab-content">
                {% if explorer.mods %}
                    {% for i in explorer.mods.get('esl', []) %}
                        <tr class="{% if loop.index0 % 2 != 0 %} bg-light{% endif %}" title="{{ i }}">
                            <td>
                                <input type="checkbox" class="checkbox" name="{{ i }}" id="" value="{{ true }}" onfocus="this.select()">
                            </td>
                            <td class="lm-table-text lm-table-sub75 text-truncate">{{ i.name }}</td>
                        </tr>
                    {% endfor %}
                {% endif %}
            </table>

            <!-- Record Details - Layer 3 (with a record selected) -->
            <table id="selectedRecordDetails" class="lm-section-table lm-layer3">
            <!-- OLD: width: 100%; height: 100%; position: absolute; top: 0; left: 0; -->
                {% for i in ["editorID", "formID", "mod", "name", "type"] %}
                    <tr>
                        <td class="lm-table-text lm-table-sub80">
                            <span class="lm-table-subcol-secondary lm-text-title">{{ i[0].upper() + i[1:] }}</span>
                            <span id="recordDetails{{ i[0].upper() + i[1:] }}" class="lm-table-subcol-primary text-break"></span>
                        </td>
                        <td class="dtable-col-btn">
                            <button type="button" class="btn-copy btn-unstyled mtable-btn" title="Copy value" data-target="recordDetails{{ i[0].upper() + i[1:] }}">
                                <img src="{{ url_for('static', filename='img/copy-solid.svg') }}" />
                            </button>
                        </td>
                    </tr>
                {% endfor %}
            </table>
            
        </div>


        <!-- Menu Command Panel: Get Records from Mods & Filter Records - Layer 2: Command Panel -->
        <div class="lm-element lm-section lm-section-panel lm-layer2">
            <!-- <button type="submit" name="get_mods_records_submit" value=""
                    class="btn-unstyled card-btn card-btn-mini card-btn-sub50 text-nobreak">
                    Filter
            </button> -->
            <span class="lm-section-panel-btn">
                <button type="submit" name="explorer_records_parse" class="btn-unstyled menu-btn menu-btn-big" title="Get records from selected mods">
                    <img src="{{ url_for('static', filename='img/arrow-down-wide-short-solid.svg') }}" />
                </button>
                <div title="Filter" class="menu-cat-icon">
                    <img src="{{ url_for('static', filename='img/filter-solid-shady.svg') }}" />
                </div>
            </span>
            
            <span class="lm-section-panel-tags">
                {% for i in ["None", "Distributable", "RecordType", "Actor"] %}
                    {% set is_active = (i == 'RecordType' and explorer.filter == user_records.record_type.name) or (explorer.filter == i) %}
                    <button type="submit" name="explorer_records_filter_submit" value="{{ user_records.record_type.name if i == "RecordType" else i }}"
                            class="btn-unstyled menu-btn-tag{% if is_active %} menu-btn-tag-active{% endif %}">
                            {% if i == "RecordType" %}
                                <span class="menu-btn-tag-text">{{ user_records.record_type.name + "s" }}</span>
                            {% else %}
                                <span class="menu-btn-tag-text">{{ i if i == "None" else i + "s" }}</span>
                            {% endif %}
                            <span>
                                <div class="marker-circle {{ markers_colors.get(user_records.record_type.name.lower()) if i == "RecordType" else markers_colors.get(i.lower()) }}"></div>
                            </span>
                    </button>
                {% endfor %}
            </span>
        </div>

        <!-- Menu Records List - Layer 2: Section 3 -->
        <div class="lm-element lm-section lm-s2 lm-layer2 bg-dark">
            <table class="lm-section-table" id="recordsTable">
                <!-- <thead><tr><th>Import distributed records from...</th></tr></thead> -->
                {% if explorer.references %}
                    {% for record_type in explorer.references %}
                        {% if record_type in explorer.filtersets %}
                            {% for i in explorer.references.get(record_type) %}
                                <tr class="lm-s2-table-row{% if loop.index0 % 2 != 0 %} bg-light{% endif %}"
                                    data-ref='"editorID": "{{ i.editor_id }}", "formID": "{{ FormId(value=i.form_id).value }}", "mod": "{{ i.mod }}", "name": "{{ i.name }}", "type": "{{ record_type.capitalize() }}"'>

                                    <!-- RecordType marker -->
                                    <td title="{{ record_type }}">
                                        <div class="marker-circle{% if i.type %} {{ markers_colors.get(record_type) }}{% endif %}"></div>       <!-- modifier la condition et faire un appel avec un get dans un dict associant les RefTypes -->
                                    </td>

                                    <!-- Record EditorID & Origin Mod -->
                                    <td class="lm-table-text lm-table-sub70 text-truncate" title="{{ i.name if i.name else '-- this record has no name --' }}">
                                        <span class="lm-table-subcol-primary text-truncate">
                                            {{ i.editor_id }}
                                        </span>
                                        <span class="text-truncate lm-table-subcol-secondary lm-text-info" title="{{ i.mod }}">
                                            {{ i.mod[:-4] }}
                                        </span>
                                        <!-- Other properties: i.type, i.name, i.form_id or better FormId(value=i.form_id).value -->
                                    </td>
                                    <!-- DEBUG CELLS -->
                                    <!-- <td>loop.index0</td> -->
                                    <!-- <td>i.get('selected')</td> -->

                                    <!-- Copy Buttons -->
                                    <!-- Copy Record ID as "FormID~mod" -->
                                    <td class="dtable-col-btn">
                                        <button type="button" class="btn-copy btn-unstyled mtable-btn" title="Copy FormID" data-text="{{ FormId(value=i.form_id).value }}~{{ i.mod }}">
                                            <img src="{{ url_for('static', filename='img/copy-solid.svg') }}" />
                                        </button>
                                    </td>
                                    <!-- Copy Record ID as "EditorID" -->
                                    <td class="dtable-col-btn">
                                        <button type="button" class="btn-copy btn-unstyled mtable-btn" title="Copy EditorID" data-text="{{ i.editor_id }}">
                                            <img src="{{ url_for('static', filename='img/copy-solid.svg') }}" />
                                        </button>
                                    </td>

                                    <!-- Context Menu (Right click) -->
                                    <td class="context-menu lm-table-row-context bg-standout" data-active="false">
                                        <!-- Auto fill ID field with selected Record's "FormID~mod" -->
                                        <button type="submit" name="explorer_record_fill_id_submit" title="Fill ID with FormID"
                                                class="btn-context btn-action btn-unstyled mtable-btn" value="{{ FormId(value=i.form_id).value }}~{{ i.mod }}">
                                            <img src="{{ url_for('static', filename='img/clone-solid-light.svg') }}" />
                                        </button>
                                        <!-- Auto fill ID field with selected Record's "EditorID" -->
                                        <button type="submit" name="explorer_record_fill_id_submit" title="Fill ID with EditorID"
                                                class="btn-context btn-action btn-unstyled mtable-btn" value="{{ i.editor_id }}">
                                            <img src="{{ url_for('static', filename='img/clone-solid.svg') }}" />
                                        </button>
                                    </td>
                                    
                                </tr>
                            {% endfor %}
                        {% endif %}
                    {% endfor %}
                {% endif %}
            </table>
        </div>

    </div>

</form>




<script>
    function resetTabCheckboxes() {
        const tabCheckboxes = document.querySelectorAll('.tab-checkbox');
        tabCheckboxes.forEach(function(tabCheckbox) {
            tabCheckbox.checked = false;
            const contentId = tabCheckbox.getAttribute('id').replace('input', 'content');
            const content = document.getElementById(contentId);
            content.style.display = 'none';
        });
    }

    function closeRecordDetails() {
        // Masquer le displayer de détails de record et son header
        const recordHeader = document.getElementById('selectedRecordHeader');
        const recordDetails = document.getElementById('selectedRecordDetails');
        recordHeader.style.display = 'none';
        recordDetails.style.display = 'none';

        // Afficher les onglets de sélection de plugins
        const espTab = document.getElementById('displayEspTab');
        const esmTab = document.getElementById('displayEsmTab');
        const eslTab = document.getElementById('displayEslTab');
        espTab.style.display = 'block';
        esmTab.style.display = 'block';
        eslTab.style.display = 'block';
    }

    function handleTabCheckboxSelection() {
        document.addEventListener('DOMContentLoaded', function() {
            const tabCheckboxes = document.querySelectorAll('.tab-checkbox');

            tabCheckboxes.forEach(function(checkbox) {
                checkbox.addEventListener('change', function() {
                    const contentId = this.getAttribute('id').replace('input', 'content');
                    const content = document.getElementById(contentId);

                    if (this.checked) {
                        content.style.display = 'block';
                    } else {
                        content.style.display = 'none';
                    }
                });
            });
        });
    }

    function handleCopyButtonClick() {
        // Écouteur d'événement sur l'élément parent (la table)
        document.getElementById('recordsTable').addEventListener('click', function(event) {
            // console.log(event.target);                                                                       // DEBUG
            // Vérifie si l'élément cliqué est un bouton avec la classe "btn-copy" (copy-button)
            const button = event.target.closest('.btn-copy');                                                   // OLD: event.target.classList.contains('btn-copy')
            if (button) {
                // Un bouton "Copier" a été cliqué --> effectuer ici la logique de copie de texte
                // Récupère le texte associé à cette ligne depuis l'attribut data-text
                const textToCopy = button.getAttribute('data-text');
                navigator.clipboard.writeText(textToCopy)
                    .then(() => {
                        console.log('Copied text: ' + textToCopy);
                    })
                    .catch(err => {
                        console.error('Error while copying text: ', err);
                    });
            }
        });

        document.getElementById('selectedRecordDetails').addEventListener('click', function(event) {
            // Vérifie si l'élément cliqué est un bouton avec la classe "btn-copy" (copy-button)
            const button = event.target.closest('.btn-copy');
            if (button) {
                // Un bouton "Copier" a été cliqué --> effectuer ici la logique de copie de texte
                // Récupère l'id de l'élément (la ligne du tableau) contenant le texte à copier
                const targetId = button.getAttribute('data-target');
                // Récupère le texte associé à cette ligne depuis l'attribut data-text
                const textToCopy = document.getElementById(targetId).textContent;
                navigator.clipboard.writeText(textToCopy)
                    .then(() => {
                        console.log('Copied text: ' + textToCopy);
                    })
                    .catch(err => {
                        console.error('Error while copying text: ', err);
                    });
            }
        });
    }

    function handleRefRecordSelection() {
        // Écouteur d'événement sur l'élément parent (la table)
        document.getElementById('recordsTable').addEventListener('click', function(event) {
            // Vérifie si l'élément cliqué est une ligne du tableau de refRecords
            const selectedRecordRow = event.target.closest('tr');
            if (selectedRecordRow) {
                // Récupérer les data et les reconvertir en json
                const stringRecordData = `{${selectedRecordRow.getAttribute('data-ref')}}`;
                const recordData = JSON.parse(stringRecordData);

                // Déselectionner les onglets de séléction de mods et vider le contenu du displayer pour préparer l'affichage
                resetTabCheckboxes();

                // Masquer les onglets de sélection de plugins
                const espTab = document.getElementById('displayEspTab');
                const esmTab = document.getElementById('displayEsmTab');
                const eslTab = document.getElementById('displayEslTab');
                espTab.style.display = 'none';
                esmTab.style.display = 'none';
                eslTab.style.display = 'none';
                
                // Afficher le displayer de détails de record et son header
                const recordHeader = document.getElementById('selectedRecordHeader');
                const recordDetails = document.getElementById('selectedRecordDetails');
                recordHeader.style.display = 'flex';
                recordDetails.style.display = 'block';
                
                // Sélectionner les différentes parties du displayer
                const recordDetailsEditorID = document.getElementById('recordDetailsEditorID');
                const recordDetailsFormID = document.getElementById('recordDetailsFormID');
                const recordDetailsMod = document.getElementById('recordDetailsMod');
                const recordDetailsName = document.getElementById('recordDetailsName');
                const recordDetailsType = document.getElementById('recordDetailsType');

                // Remplir les différentes parties du displayer avec les infos contenues dans le json
                recordDetailsEditorID.textContent = recordData.editorID;
                recordDetailsFormID.textContent = recordData.formID;
                recordDetailsMod.textContent = recordData.mod;
                recordDetailsName.textContent = recordData.name;
                recordDetailsType.textContent = recordData.type;
            }

            // TODO Ideas for a better user experience
            //      Do the same while right clicking (contextmenu) --------------------------------------------------------------------------------------
            //      Close any opened contextmenu while left clicking ------------------------------------------------------------------------------------
        });
    }

    function handleRefRecordContextMenu() {
        // Écouteur d'événement sur l'élément parent (la table)
        document.getElementById('recordsTable').addEventListener('contextmenu', function(event) {
            // Vérifie si l'élément cliqué est une ligne du tableau de refRecords
            const selectedRecordRow = event.target.closest('tr');
            if (selectedRecordRow) {
                // Empêche le menu contextuel par défaut de s'afficher
                event.preventDefault();
                
                // Recherche la <td> ayant la classe "context-menu" et les <button> ayant la class "btn-context" dans la ligne (<tr>) cliquée
                const contextMenuCol = selectedRecordRow.querySelector(".context-menu");
                const contextMenuButtons = selectedRecordRow.querySelectorAll('.btn-context');
                
                // Vérifier si la <td> a été trouvée
                if (contextMenuCol) {
                    // Récupérer la valeur de data-active
                    let isContextMenuActive = contextMenuCol.getAttribute("data-active");

                    // Modifier la valeur de l'attribut data-active
                    switch(isContextMenuActive) {
                        // Si menu "inactif" lorsque cliqué, augmenter la largeur de la zone et faire apparaître son contenu progressivement, puis passer le statut du menu sur "actif"
                        case "false":
                            contextMenuButtons.forEach(btn => {
                                btn.style.transitionDelay = "2s";
                                btn.style.opacity = "1";
                            });
                            contextMenuCol.style.opacity = "0.85";
                            contextMenuCol.style.width = "100%";
                            contextMenuCol.setAttribute("data-active", "true");
                            break;
                            
                        // Si menu "actif" lorsque cliqué, réduire la largeur de la zone et faire disparaître son contenu progressivement, puis passer le statut du menu sur "inactif"
                        case "true":
                            contextMenuButtons.forEach(btn => {
                                btn.style.transitionDelay = "";
                                btn.style.opacity = "0";
                            });
                            contextMenuCol.style.opacity = "0.35";
                            contextMenuCol.style.width = "0%";
                            contextMenuCol.setAttribute("data-active", "false");
                            break;

                        default: console.error(`Unknown Value: contextMenu status is "${isContextMenuActive}"`);
                    }
                }
            }
        });

        // TODO Ideas for a better user experience
        //      Reset active contextMenus while right clicking a new contextMenu (only 1 active at the same time) ---------------------------------------

        // // Sauvegarde le contenu existant
        // const existingContent = selectedRecordRow.innerHTML;
    }

    handleTabCheckboxSelection();
    handleCopyButtonClick();
    handleRefRecordSelection();
    handleRefRecordContextMenu();
</script>


<!-- NB AUTRES IDEES (PAS ICI): ajouter un log pour dire que copie bien effectuée, ajouter des badges/tabs au-dessus de s3 pour choisir NPCs et/ou uniquement les records == RecordType actuel (vs tous) -->

<!-- TODO
A renommer en menu-* dans le CSS  et réaffecter dans html ?
rm-element
rm-btn
rm-btn-icon

Ajouter un moyen de conserver les boutons activés/contenus affichés (grâce à une condition flask sur la class/l'état checked pour les checkbox)

Disable l'affichage lorsqu'un overlay est actif

Ajouter des exclusions +/- une option par défaut dans les settings ?
-->